jsx.require(['Utils', 'Location', '{jsxAjax}.XmlHttp', 'CallBacks', 'Utils'], function() {
    HH.Resume = new function() {
        this.errorClass = 'm-resume__form__element_error';
        this.fields = [];
        this.add = function(get /* get field value */, callback) {
            var field = {
                callback:callback,
                get:get
            };
            field.id = jsx.Utils.getUniqueId(field);
            this.fields.push(field);
            return {
                stop: this._stop.bind(this, field.id)
            };
        };

        this.TIMER = 3000;
        this.WARNLIMIT = .9;

        this._stop = function(id) {
            for (var i = 0, l = this.fields.length; i < l; i++) {
                var field = this.fields[i];
                if (field.id == id) {
                    field.stop = true;
                    break;
                }
            }
        };
        this.validate = function(field) {

            var value = field.get();

            if (field.stop || value == field.value) {
                this.restartCheck();
                return;
            }

            field.value = value;
            field.callback();

            this.restartCheck();

        };
        this.callback = function(field, transport) {
            var json = this.objectFromString(transport.responseText);
            var errors = {};
            for (fieldname in json) {
                for(var i=0,l=json[fieldname].length;i<l;i++){
                    for (part in json[fieldname][i]) {
                        var name = fieldname+'.'+part;
                        errors[name] = errors[name] || [];
                        errors[name].push(json[fieldname][i][part]);
                    }
                }
            }

            field.callback(errors);


            this.restartCheck();
        };

        this.check = function() {
            if (this.fields.length > 0) {
                this.fields.forEach(this.validate, this);
            } else {
                this.restartCheck();
            }
        };
        this.restartCheck = function() {
            if (this.timer) {
                window.clearTimeout(this.timer);
            }
            this.timer = window.setTimeout(this.check.bind(this), 500);
        };
        this.objectFromString = function(string) {
            return (new Function('return ' + string.replace('\n','')))() || null;
        };


        this.getMessage = function(part,key) {
            var messages = this.getJSON().messages;
            return (messages[part] && messages[part][key] ? messages[part][key] : messages['_default'][key]) || 'Error!';
        };

        this.getConditions = function(field) {
            return this.getJSON().conditions[field];
        };


        this.getJSON = function(){ return {} };

        this.initJSON = function(conditions,messages){
            this.getJSON = function(){
                return {
                    conditions: conditions,
                    messages: messages
                }
            };
            this.check();
        };
        this.check();
    };
    jsx.loaded('{HH}.Resume');
});
