jsx.require(['{HH}.Resume'], function(){
    jsx.Components.buildComponent('{HH}.Resume.Touch',
        function(){
            this.init = function(element, params){
                this.element = element;
                this.button = jsx.Dom.$$(this.element, '.HH-Resume-Touch-Button');
                this.error = jsx.Dom.$$(this.element, '.HH-Resume-Touch-Error');
                this.resume = params.resume;
                this.retryTrl = params.retryTrl;

                if (this.button !== undefined){
                    jsx.Events.observe(this.button, 'click', this.touch.bind(this));
                    jsx.CallBacks.add('HH-Resume-Touch-Enabled', this.touchEnabled.bind(this), HH.Resume);
                };
            };
            
            this.touchEnabled = function(){
                jsx.Dom.removeClassName(this.button, 'g-hidden');
            };
            
            this.touch = function(){
                new jsxAjax.XmlHttp.Request('/applicant/resumes/touch', {
                    method: 'post',
                    parameters: {resume:this.resume, undirectable: true},
                    onSuccess: this.successAjax.bind(this),
                    onFailure: this.failedAjax.bind(this)
                });                
            };
            
            this.failedAjax = function(response){
                jsx.Dom.removeClassName(this.error, 'g-hidden');
                this.button.innerHTML = this.retryTrl;
            };
            
            this.successAjax = function(response){
                jsx.Dom.addClassName(this.error, 'g-hidden');
                jsx.Dom.addClassName(this.button, 'g-hidden');
                jsx.CallBacks.dispatch('HH-Resume-Touch-Touched', HH.Resume, []);
                try {
                    HH.conversionGoals.trackAnalyticsEvent('applicant', 'resume-edited');
                } catch(e) {}
            };
        },
        ['Dom', 'Events', 'CallBacks', '{jsxAjax}.XmlHttp']
    );
});
