jsx.require(['{HH}.Resume', '{jsxAjax}.XmlHttp'], function(){
    jsx.Components.buildComponent('{HH}.Resume.UpdateTimer',
        function(){
            this.init = function(element, params){
                this.element = element;
                this.updateTimeout = parseInt(params.updateTimeout, 10) / 1000;
                this.toUpdateContainer = jsx.Dom.$$(this.element, '.HH-Resume-UpdateTimer-ToUpdate-Container');
                this.lang = params.resumeLang;
                
                var wasUpdatedElement = jsx.Dom.$$(this.element, '.HH-Resume-UpdateTimer-WasUpdated');
                var toUpdateElement = jsx.Dom.$$(this.element, '.HH-Resume-UpdateTimer-ToUpdate');
                
                if (wasUpdatedElement !== undefined) {
                    this.wasUpdated = {
                        'name' : 'timeWasUpdated',
                        'value': Math.round(new Date().getTime() / 1000) - parseInt(params.wasUpdated, 10), 
                        'element': wasUpdatedElement,
                        'enabled': true,
                    };
                };
                
                if (toUpdateElement  !== undefined) {
                    var toUpdateValue = parseInt(params.toUpdate, 10);
                    this.toUpdate = {
                        'name': 'timeToUpdate',
                        'value': Math.round(new Date().getTime() / 1000) + toUpdateValue,
                        'element': toUpdateElement,
                        'enabled': (toUpdateValue > 0)
                    };
                };
                
                this.timer = setInterval(this.check.bind(this), 45000);
                                
                jsx.CallBacks.add('HH-Resume-Touch-Touched', this.touched.bind(this), HH.Resume);
            };
            
            
            this.check = function(){
                var params = {'lang': this.lang};
                
                [this.wasUpdated, this.toUpdate].forEach(function(obj){
                    if (!obj.enabled || !obj.value || !obj.element) {
                        return;
                    };
                    
                    var timestamp = Math.round(new Date().getTime() / 1000) - obj.value;
                    if (timestamp >= 0 && obj.name == 'timeToUpdate') {
                        obj.enabled = false;
                        jsx.Dom.addClassName(this.toUpdateContainer, 'g-hidden');
                        jsx.CallBacks.dispatch('HH-Resume-Touch-Enabled', HH.Resume, []);
                        return;
                    };
                    params[obj.name] = Math.abs(timestamp);
                }.bind(this));
                
                new jsxAjax.XmlHttp.Request('/applicant/resumes/human_datetime', {
                    method: 'get',
                    parameters: params,
                    onSuccess: this.successAjax.bind(this)
                });                  
            };
            
            this.successAjax = function(response){
                var resp = JSON.parse(response.responseText);

                [this.wasUpdated, this.toUpdate].forEach(function(obj){
                    if (resp[obj.name] !== undefined){
                        obj.element.innerHTML = resp[obj.name];       
                    };
                });
            };
            
            this.touched = function(){
                 jsx.Dom.removeClassName(this.toUpdateContainer, 'g-hidden');
                 this.wasUpdated.value = Math.round(new Date().getTime() / 1000) + 1;
                 this.toUpdate.value = Math.round(new Date().getTime() / 1000) + this.updateTimeout;
                 this.toUpdate.enabled = true;
                 this.check();
                 this.animateColor(this.wasUpdated.element, 'FFFFFF', 'D3FAA0', 1000);
            };
            
            this.animateColor = function(el, startcolor, endcolor, duration){
                var iterations = 250;

                while (endcolor.length < 6) {
                    endcolor = '0' + endcolor;
                }
                
                var colors = [0,1,2].map(
                    function(i){
                        var color = {};
                        color.value = parseInt(startcolor.slice(i*2,i*2+2),16);
                        color.delta = parseInt(endcolor.slice(i*2,i*2+2),16)-color.value;
                        color.step = color.delta/iterations;
                        return color;
                    }
                );
                
                var setColor = function(iteration){
                    el.style.background = '#' + [0,1,2].map(function(i){return Math.round(colors[i].value + colors[i].step*iteration).toString(16)}).join('').toUpperCase();
                    iteration--;
                    if (iteration > 0) setTimeout(setColor.bind(this, iteration), duration/iterations);                
                };
              
                setColor(iterations);
            };
        },
        ['Dom', 'Strings', 'Events', 'CallBacks']
    );
});
